Program PCF8591_Speicheroszi;
Uses CRT, Dos, Graph, I2C_LPT1;
var   Puffer : Array [1..4000] of Byte;
      DA_Puffer : Array [1..1000] of Byte;
      Ch                :   Char;
      xres, yres, Zeit  : Integer;

procedure DAaus (Steuerbyte, Wert: Byte);
begin
  Start;
  Ausgeben (72 * 2);           { Adresse 72, schreiben }
  Ausgeben (Steuerbyte);       
  Ausgeben (Wert);             
  Stop;                        
end;                           

function ADein: Byte;          
begin                          
  Start;                       
  Ausgeben (72 * 2 + 1);       { Adresse 72, lesen }
  ADein := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure AD_Serie;
var n: Integer;
    Dummy : Byte;
begin
  DAaus (4,100);               { Steuerbyte=4 }
  Start;
  Ausgeben (72 * 2 + 1);       { Adresse 72, lesen }
  Inline ($FA);                { Interrupt sperren }
  Dummy := Einlesen;           
  Acknowledge;                 
  for n := 1 to 4000 do begin  
    Puffer [n] := Einlesen;    { 4000 Bytes einlesen }
    Acknowledge;               
  end;                         
  Inline ($FB);                { Interrupt freigeben }
  Dummy := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure DA_Tabelle;
var n : Integer;
begin
  for n := 1 to 250 do DA_Puffer [n] := 55;
  for n := 251 to 450 do DA_Puffer [n] := 205;
  for n := 451 to 1000 do DA_Puffer [n] := 55;
end;

procedure AD_DA_Serie;
var n, m : Integer;
    Dummy : Byte;
begin
  for n := 1 to 1000 do begin
    DAaus (68,DA_Puffer[n]);        { Steuerbyte=68 }
    Start;
    Ausgeben (72 * 2 + 1);          { Adresse 72, lesen }
    Dummy := Einlesen; Acknowledge;
    Puffer [4*(n-1)+1] := Einlesen; Acknowledge;
    Puffer [4*(n-1)+2] := Einlesen; Acknowledge;
    Puffer [4*(n-1)+3] := Einlesen; Acknowledge;
    Puffer [4*(n-1)+4] := Einlesen; KeinAcknowledge;
    Stop;
  end;
end;

procedure Speichern (dateiname :String);
var  f : Text;
     n, r : Integer;
begin
  Assign(f,dateiname);
  {$I-} ReWrite(f); {$I+}
  r := IOresult;
  if  r = 0 then begin
     for n:=0 to 999 do begin;
       write (f,Puffer [4*n+1],#9);
       write (f,Puffer [4*n+2],#9);
       write (f,Puffer [4*n+3],#9);
       writeln (f,Puffer [4*n+4]);
     end;
     close (f);
  end;
end;

procedure GrafikInit;
var Graphdriver, Graphmode, Graphcode : Integer;
begin
  graphDriver := Detect;
  InitGraph (Graphdriver, Graphmode, '');
  xres := GetmaxX; yres := GetmaxY;
end;

function wx (x: Integer): Integer;
 begin
   wx :=  round (x * (xres/1000));
 end;

function wy (y: Integer): Integer;
 begin
   wy :=  round ((1000-y)*(yres/1000));
 end;

procedure DiagrammInit;
var i, j : Integer;
     Zahl    : String;
begin
   Grafikinit;
   Line (wx(100),wy(100),wx(900),wy(100));
   Line (wx(900),wy(100),wx(900),wy(868));
   Line (wx(900),wy(868),wx(100),wy(868));
   Line (wx(100),wy(868),wx(100),wy(100));
   SetLineStyle (1,2,1);
   for i := 1 to 10 do
     Line (wx(100),wy(100+75*i),wx(900),wy(100+75*i));
   SetTextJustify (2,1);
   for i := 0 to 10 do
     begin
       Str (0.5*i:2:1,Zahl);
       Zahl := concat (Zahl, ' V');
       OutTextXY (wx(90),wy(100+75*i),Zahl);
     end;
   for i := 1 to 10 do
     Line (wx(100+80*i),wy(100),wx(100+80*i),wy(868));
   SetTextJustify (1,1);
   for i := 0 to 10 do
     begin
       Str (100*i,Zahl);
       OutTextXY (wx(100+80*i),wy(70),Zahl);
     end;
end;

procedure Plot (Kanal : Integer);
var i : Integer;
    Stepweite : real;
begin
  SetLineStyle (0,2,1);
  moveto (wx(100),wy(100+3*Puffer[Kanal]));
  for i := 0 to 999 do
    lineto (wx(100+round(i*0.8)),wy (100+3*Puffer[i*4+Kanal]));
end;

begin
  ClrScr;
  Writeln ('Bitte Taste drcken, um Messung zu starten');
  Repeat until KeyPressed; Ch := ReadKey;
  DA_Tabelle;
  AD_DA_Serie;
  { AD_Serie; }
  DiagrammInit;
  repeat;
    repeat until KeyPressed;
    Ch := upcase (ReadKey);
      If Ch in ['1'..'4'] then Plot (ord(Ch)-48);
      If Ch = 'S' then Speichern ('Ausgabe.Dat');
      If Ch = ' ' then begin CloseGraph; DiagrammInit end;
  until Ch = chr (27);
  CloseGraph;
end.
